package daruma.geometry;

import daruma.geometry.DrmGeometry;

import com.vividsolutions.jts.geom.* ;
import com.vividsolutions.jts.geom.impl.* ;
import daruma.geometry.OgcGeometryFactory ;

import daruma.util.Itk ;

public class DrmPoint extends DrmGeometry
{
	private	double	x;
	private	double	y;

	public	DrmPoint( double  x ,  double  y )
	{
		this.x = x;
		this.y = y;
	}

	public	double	getX()
	{
		return( this.x );
	}

	public	double	getY()
	{
		return( this.y );
	}

	public	double	setX(double x)
	{
		return( this.x = x);
	}

	public	double	setY(double y)
	{
		return( this.y = y);
	}

	public DrmPoint set(double x, double y) {
	    this.x = x ;
	    this.y = y ;
	    return this ;
	}

	public	boolean	equals( Object  point )
	{
		assert( point instanceof DrmPoint );

		return( this.equals( (DrmPoint)point ) );
	}

	public	boolean	equals( DrmPoint  point )
	{
		/**
		 * XXX:
		 *  Simple compare method like "this.x == point.x" is
		 * not correct. Because floating point number can be
		 * round to some other number.
		 */

		return( (Double.doubleToLongBits(this.x) == Double.doubleToLongBits(point.x)) &&
			(Double.doubleToLongBits(this.y) == Double.doubleToLongBits(point.y)) );
	}

	public	int	hashCode()
	{
		return( new Double( this.x ).hashCode()
			^ new Double( this.y ).hashCode() );
	}

    //------------------------------------------------------------
    /**
     * geometry generator
     */
    public Geometry genGeometry(OgcGeometryFactory geoFactory) {
	return geoFactory.genPoint2D(this.x, this.y) ;
    }
    
}
